"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var JSRuleFinder_1 = require("./shared/JSRuleFinder");
var UPFinder_1 = require("./shared/UPFinder");
var BabelPlugin = (function () {
    function BabelPlugin() {
    }
    BabelPlugin.prototype.configure = function (builder, spin) {
        if (builder.stack.hasAny(['babel', 'es6']) &&
            builder.stack.hasAll(['webpack']) &&
            (!builder.stack.hasAny('dll') || builder.stack.hasAny(['android', 'ios']))) {
            if (builder.stack.hasAny(['babel', 'es6']) && !builder.stack.hasAny('dll')) {
                builder.config = spin.merge({
                    entry: {
                        index: ['babel-polyfill']
                    }
                }, builder.config);
            }
            var jsRuleFinder = new JSRuleFinder_1.default(builder);
            var jsRule = jsRuleFinder.findAndCreateJSRule();
            var _a = builder.babelConfig || { merge: {} }, merge = _a.merge, config = __rest(_a, ["merge"]);
            var cacheDirectory = builder.cache === false || (builder.cache === 'auto' && !spin.dev)
                ? false
                : path.join(builder.cache === true || (builder.cache === 'auto' && spin.dev) ? '.cache' : builder.cache, 'babel-loader');
            var babelrc = new UPFinder_1.default(builder).find(['.babelrc', '.babelrc.js']);
            jsRule.use = {
                loader: builder.require.probe('heroku-babel-loader') ? 'heroku-babel-loader' : 'babel-loader',
                options: !!babelrc
                    ? { babelrc: true, cacheDirectory: cacheDirectory }
                    : spin.mergeWithStrategy(merge, {
                        babelrc: false,
                        cacheDirectory: cacheDirectory,
                        compact: !spin.dev,
                        presets: ['react', ['env', { modules: false }], 'stage-0'].concat(spin.dev ? [] : [['minify', { mangle: false }]]),
                        plugins: ['transform-runtime', 'transform-decorators-legacy', 'transform-class-properties'],
                        only: jsRuleFinder.extensions.map(function (ext) { return '*.' + ext; })
                    }, config)
            };
        }
    };
    return BabelPlugin;
}());
exports.default = BabelPlugin;
//# sourceMappingURL=BabelPlugin.js.map