"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var default_1 = (function () {
    function default_1(builder) {
        this.dirs = builder.require.cwd.split(path.sep);
    }
    default_1.prototype.find = function (candidates) {
        var foundPath;
        var dirs = this.dirs.slice(0);
        while (dirs.length > 0) {
            var curDir = path.join.apply(path, dirs);
            for (var _i = 0, candidates_1 = candidates; _i < candidates_1.length; _i++) {
                var candidate = candidates_1[_i];
                var candidatePath = path.join(curDir, candidate);
                if (fs.existsSync(candidatePath)) {
                    foundPath = candidatePath;
                    break;
                }
            }
            if (foundPath) {
                break;
            }
            dirs.pop();
        }
        return foundPath;
    };
    return default_1;
}());
exports.default = default_1;
//# sourceMappingURL=UPFinder.js.map